﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.SQLite;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace IDEs2023_1
{
    public partial class Form1 : Form
    {
        String connectionString = "Data source=ides20231.db;Version=3";
        SQLiteConnection connection;
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            connection = new SQLiteConnection(connectionString);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            connection.Open();
            String createTableSQL = "Create table if not exists House(" +
                "House_ID integer primary key autoincrement," +
                "Square_meters integer," +
                "Address Text," +
                "Price integer," +
                "Heating Text," +
                "Photo Text)";
            SQLiteCommand command = new SQLiteCommand(createTableSQL, connection);
            command.ExecuteNonQuery();
            connection.Close();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            connection.Open();
            String insertSQL = "Insert into House(" +
                "Square_meters,Address,Price,Heating,Photo) " +
                "values(@meters,@address,@price,@heating,@photo)";
            SQLiteCommand command = new SQLiteCommand(insertSQL, connection);
            command.Parameters.AddWithValue("meters", int.Parse(textBox1.Text));
            command.Parameters.AddWithValue("address", textBox2.Text);
            command.Parameters.AddWithValue("price", int.Parse(textBox3.Text));
            command.Parameters.AddWithValue("heating", comboBox1.Text);
            command.Parameters.AddWithValue("photo", textBox5.Text);
            int rows = command.ExecuteNonQuery();
            connection.Close();
            MessageBox.Show(rows + " record inserted");
            pictureBox1.Load(textBox5.Text);
        }

        private void button3_Click(object sender, EventArgs e)
        {
            connection.Open();
            String selectIDsSQL = "Select House_ID from House";
            SQLiteCommand command = new SQLiteCommand(selectIDsSQL, connection);
            SQLiteDataReader sQLiteDataReaderreader = command.ExecuteReader();
            comboBox2.Items.Clear();
            while (sQLiteDataReaderreader.Read())
            {
                comboBox2.Items.Add(sQLiteDataReaderreader.GetInt16(0));
            }
            MessageBox.Show("Done!");
            connection.Close();
        }

        private void comboBox2_SelectedIndexChanged(object sender, EventArgs e)
        {
                connection.Open();
                String selectIDsSQL = "Select * from House " +
                    "where House_ID=@id";
                SQLiteCommand command = new SQLiteCommand(selectIDsSQL, connection);
                command.Parameters.AddWithValue("id",int.Parse(comboBox2.Text));
                SQLiteDataReader sQLiteDataReaderreader = command.ExecuteReader();
                while (sQLiteDataReaderreader.Read())
                {
                    textBox1.Text = sQLiteDataReaderreader.GetInt16(1).ToString();
                    textBox2.Text = sQLiteDataReaderreader.GetString(2);
                    textBox3.Text = sQLiteDataReaderreader.GetInt32(3).ToString();
                    comboBox1.Text = sQLiteDataReaderreader.GetString(4);
                    textBox5.Text = sQLiteDataReaderreader.GetString(5);
                    pictureBox1.Load(sQLiteDataReaderreader.GetString(5));
                }
                connection.Close();
        }

        private void button4_Click(object sender, EventArgs e)
        {
            if (comboBox2.Items.Count > 0)
            {
                connection.Open();
                String updateSQL = "Update House " +
                    "set Square_meters=@meters," +
                    "Address=@address," +
                    "Price=@price," +
                    "Heating=@heating," +
                    "Photo=@photo " +
                    "where House_ID=@id";
                SQLiteCommand command = new SQLiteCommand(updateSQL, connection);
                command.Parameters.AddWithValue("meters", int.Parse(textBox1.Text));
                command.Parameters.AddWithValue("address", textBox2.Text);
                command.Parameters.AddWithValue("price", int.Parse(textBox3.Text));
                command.Parameters.AddWithValue("heating", comboBox1.Text);
                command.Parameters.AddWithValue("photo", textBox5.Text);
                command.Parameters.AddWithValue("id", int.Parse(comboBox2.Text));
                int rows = command.ExecuteNonQuery();
                connection.Close();
                MessageBox.Show(rows + " record updated!");
                pictureBox1.Load(textBox5.Text);
            }
            else
            {
                MessageBox.Show("Please select at least one house first!");
            }
        }

        private void button5_Click(object sender, EventArgs e)
        {
            if (comboBox1.SelectedIndex < 0)
            {
                MessageBox.Show("Please select a heating type!");
                return;
            }
            connection.Open();
            String selectIDsSQL = "Select House_ID from House " +
                "where Heating=@heating";
            SQLiteCommand command = new SQLiteCommand(selectIDsSQL, connection);
            command.Parameters.AddWithValue("heating", comboBox1.Text);
            SQLiteDataReader sQLiteDataReaderreader = command.ExecuteReader();
            comboBox2.Items.Clear();
            while (sQLiteDataReaderreader.Read())
            {
                comboBox2.Items.Add(sQLiteDataReaderreader.GetInt16(0));
            }
            MessageBox.Show("Done!");
            connection.Close();
        }

    }
}
